unit ID3v1;

interface
 uses
  SysUtils, Classes;

  Type
   TagMP3 = record
     Titre       : String;
     Artiste     : String;
     Album       : String;
     Annee       : String;
     Commentaire : String;
     TrackNb     : Byte;
     Genre       : Byte;
  end;

  Function  Lire_Tag(Fichier :string): TagMP3;
  Procedure Ecrire_Tag(Fichier :string; VotreTag : TagMP3);

implementation

{-=-=-=-=-=-= LECTURE DU TAG =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
Function Lire_Tag(Fichier :string): TagMP3;
var
    Fs  : TFileStream;
    Tag : Array[1..128] of Char;
    s   : string;
    T   : TagMP3;
begin
    Fs := TFileStream.Create(Fichier, fmOpenRead or fmShareDenyNone);
     Fs.Seek(-128, soFromEnd);
     Fs.Read(Tag,128);
    Fs.Free;

    s := Copy(Tag,1,3);
    if s <> 'TAG' then
    begin
        Result := T;
        Exit;
    end;

    T.Titre       := Trim(Copy(Tag,04,30));
    T.Artiste     := Trim(Copy(Tag,34,30));
    T.Album       := Trim(Copy(Tag,64,30));
    T.Annee       := Trim(Copy(Tag,94,4));
    T.Commentaire := Trim(Copy(Tag,98,29));
    T.TrackNb     := Ord(Tag[127]);
    T.Genre       := Ord(Tag[128]);

    Result := T;
  end;

{-=-=-=-=-=-= ECRITURE DU TAG =-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-}
Procedure Ecrire_Tag(Fichier :string; VotreTag : TagMP3);
var
    Fs   : TFileStream;
    i    : integer;
    b    : byte;
    Tag  : Array[1..3] of Char;
const
    c    : byte = 0;
begin
    Fs := TFileStream.Create(Fichier, fmOpenReadWrite + fmShareDenyWrite);
{ on se positionne au bon endroit }
    Fs.Seek(-128, soFromEnd);
{ on regarde s'il existe dj un TAG }
    Fs.Read(TAG, 3);
    if TAG = 'TAG' then
        Fs.Seek(-128, soFromEnd)
    else
        Fs.Seek(0, soFromEnd);
{ on ecrit TAG }
    Fs.Write('TAG', 3);

{ TiTre }
    VotreTag.Titre := Copy(VotreTag.Titre,1 , 30);
    For i := 1 to Length(VotreTag.Titre) do
    begin
        b := Ord(VotreTag.Titre[i]);
        Fs.Write(b,1);
    end;
    for i := Length(VotreTag.Titre) to 29 do
        Fs.Write(c, 1);

{ Artiste }
    VotreTag.Artiste := Copy(VotreTag.Artiste,1 , 30);
    For i := 1 to Length(VotreTag.Artiste) do
    begin
        b := Ord(VotreTag.Artiste[i]);
        Fs.Write(b,1);
    end;
    for i := Length(VotreTag.Artiste) to 29 do
        Fs.Write(c, 1);

{ Album }
    VotreTag.Album := Copy(VotreTag.Album,1 , 30);
    For i := 1 to Length(VotreTag.Album) do
    begin
        b := Ord(VotreTag.Album[i]);
        Fs.Write(b,1);
    end;
    for i := Length(VotreTag.Album) to 29 do
        Fs.Write(c, 1);

{ Anne }
    VotreTag.Annee := Copy(VotreTag.Annee,1 , 4);
    For i := 1 to Length(VotreTag.Annee) do
    begin
        b := Ord(VotreTag.Annee[i]);
        Fs.Write(b,1);
    end;
    for i := Length(VotreTag.Annee) to 3 do
        Fs.Write(c, 1);

{ Commentaire }
    VotreTag.Commentaire := Copy(VotreTag.Commentaire,1 , 29);
    For i := 1 to Length(VotreTag.Commentaire) do
    begin
        b := Ord(VotreTag.Commentaire[i]);
        Fs.Write(b,1);
    end;
    for i := Length(VotreTag.Commentaire) to 28 do
        Fs.Write(c, 1);

{ Track Nb }
    b := VotreTag.TrackNb;
    Fs.Write(b,1);

{ Genre }
    b := VotreTag.Genre;
    Fs.Write(b,1);

    Fs.Free;
end;


end.
